summaryrefslogtreecommitdiffstats
path: root/.ci/scripts/windows
diff options
context:
space:
mode:
Diffstat (limited to '.ci/scripts/windows')
-rw-r--r--.ci/scripts/windows/docker.sh50
-rw-r--r--.ci/scripts/windows/exec.sh5
-rw-r--r--.ci/scripts/windows/scan_dll.py106
-rw-r--r--.ci/scripts/windows/upload.sh13
4 files changed, 174 insertions, 0 deletions
diff --git a/.ci/scripts/windows/docker.sh b/.ci/scripts/windows/docker.sh
new file mode 100644
index 000000000..f7093363b
--- /dev/null
+++ b/.ci/scripts/windows/docker.sh
@@ -0,0 +1,50 @@
+#!/bin/bash -ex
+
+cd /yuzu
+
+ccache -s
+
+# Dirty hack to trick unicorn makefile into believing we are in a MINGW system
+mv /bin/uname /bin/uname1 && echo -e '#!/bin/sh\necho MINGW64' >> /bin/uname
+chmod +x /bin/uname
+
+# Dirty hack to trick unicorn makefile into believing we have cmd
+echo '' >> /bin/cmd
+chmod +x /bin/cmd
+
+mkdir build || true && cd build
+cmake .. -G Ninja -DCMAKE_TOOLCHAIN_FILE="$(pwd)/../CMakeModules/MinGWCross.cmake" -DUSE_CCACHE=ON -DYUZU_USE_BUNDLED_UNICORN=ON -DENABLE_COMPATIBILITY_LIST_DOWNLOAD=ON -DCMAKE_BUILD_TYPE=Release
+ninja
+
+# Clean up the dirty hacks
+rm /bin/uname && mv /bin/uname1 /bin/uname
+rm /bin/cmd
+
+ccache -s
+
+echo "Tests skipped"
+#ctest -VV -C Release
+
+echo 'Prepare binaries...'
+cd ..
+mkdir package
+
+QT_PLATFORM_DLL_PATH='/usr/x86_64-w64-mingw32/lib/qt5/plugins/platforms/'
+find build/ -name "yuzu*.exe" -exec cp {} 'package' \;
+
+# copy Qt plugins
+mkdir package/platforms
+cp "${QT_PLATFORM_DLL_PATH}/qwindows.dll" package/platforms/
+cp -rv "${QT_PLATFORM_DLL_PATH}/../mediaservice/" package/
+cp -rv "${QT_PLATFORM_DLL_PATH}/../imageformats/" package/
+rm -f package/mediaservice/*d.dll
+
+for i in package/*.exe; do
+ # we need to process pdb here, however, cv2pdb
+ # does not work here, so we just simply strip all the debug symbols
+ x86_64-w64-mingw32-strip "${i}"
+done
+
+pip3 install pefile
+python3 .ci/scripts/windows/scan_dll.py package/*.exe "package/"
+python3 .ci/scripts/windows/scan_dll.py package/imageformats/*.dll "package/"
diff --git a/.ci/scripts/windows/exec.sh b/.ci/scripts/windows/exec.sh
new file mode 100644
index 000000000..d6a994856
--- /dev/null
+++ b/.ci/scripts/windows/exec.sh
@@ -0,0 +1,5 @@
+#!/bin/bash -ex
+
+mkdir -p "ccache" || true
+chmod a+x ./.ci/scripts/windows/docker.sh
+docker run -e CCACHE_DIR=/yuzu/ccache -v $(pwd):/yuzu yuzuemu/build-environments:linux-mingw /bin/bash -ex /yuzu/.ci/scripts/windows/docker.sh
diff --git a/.ci/scripts/windows/scan_dll.py b/.ci/scripts/windows/scan_dll.py
new file mode 100644
index 000000000..163183f2e
--- /dev/null
+++ b/.ci/scripts/windows/scan_dll.py
@@ -0,0 +1,106 @@
+import pefile
+import sys
+import re
+import os
+import queue
+import shutil
+
+# constant definitions
+KNOWN_SYS_DLLS = ['WINMM.DLL', 'MSVCRT.DLL', 'VERSION.DLL', 'MPR.DLL',
+ 'DWMAPI.DLL', 'UXTHEME.DLL', 'DNSAPI.DLL', 'IPHLPAPI.DLL']
+# below is for Ubuntu 18.04 with specified PPA enabled, if you are using
+# other distro or different repositories, change the following accordingly
+DLL_PATH = [
+ '/usr/x86_64-w64-mingw32/bin/',
+ '/usr/x86_64-w64-mingw32/lib/',
+ '/usr/lib/gcc/x86_64-w64-mingw32/7.3-posix/'
+]
+
+missing = []
+
+
+def parse_imports(file_name):
+ results = []
+ pe = pefile.PE(file_name, fast_load=True)
+ pe.parse_data_directories()
+
+ for entry in pe.DIRECTORY_ENTRY_IMPORT:
+ current = entry.dll.decode()
+ current_u = current.upper() # b/c Windows is often case insensitive
+ # here we filter out system dlls
+ # dll w/ names like *32.dll are likely to be system dlls
+ if current_u.upper() not in KNOWN_SYS_DLLS and not re.match(string=current_u, pattern=r'.*32\.DLL'):
+ results.append(current)
+
+ return results
+
+
+def parse_imports_recursive(file_name, path_list=[]):
+ q = queue.Queue() # create a FIFO queue
+ # file_name can be a string or a list for the convience
+ if isinstance(file_name, str):
+ q.put(file_name)
+ elif isinstance(file_name, list):
+ for i in file_name:
+ q.put(i)
+ full_list = []
+ while q.qsize():
+ current = q.get_nowait()
+ print('> %s' % current)
+ deps = parse_imports(current)
+ # if this dll does not have any import, ignore it
+ if not deps:
+ continue
+ for dep in deps:
+ # the dependency already included in the list, skip
+ if dep in full_list:
+ continue
+ # find the requested dll in the provided paths
+ full_path = find_dll(dep)
+ if not full_path:
+ missing.append(dep)
+ continue
+ full_list.append(dep)
+ q.put(full_path)
+ path_list.append(full_path)
+ return full_list
+
+
+def find_dll(name):
+ for path in DLL_PATH:
+ for root, _, files in os.walk(path):
+ for f in files:
+ if name.lower() == f.lower():
+ return os.path.join(root, f)
+
+
+def deploy(name, dst, dry_run=False):
+ dlls_path = []
+ parse_imports_recursive(name, dlls_path)
+ for dll_entry in dlls_path:
+ if not dry_run:
+ shutil.copy(dll_entry, dst)
+ else:
+ print('[Dry-Run] Copy %s to %s' % (dll_entry, dst))
+ print('Deploy completed.')
+ return dlls_path
+
+
+def main():
+ if len(sys.argv) < 3:
+ print('Usage: %s [files to examine ...] [target deploy directory]')
+ return 1
+ to_deploy = sys.argv[1:-1]
+ tgt_dir = sys.argv[-1]
+ if not os.path.isdir(tgt_dir):
+ print('%s is not a directory.' % tgt_dir)
+ return 1
+ print('Scanning dependencies...')
+ deploy(to_deploy, tgt_dir)
+ if missing:
+ print('Following DLLs are not found: %s' % ('\n'.join(missing)))
+ return 0
+
+
+if __name__ == '__main__':
+ main()
diff --git a/.ci/scripts/windows/upload.sh b/.ci/scripts/windows/upload.sh
new file mode 100644
index 000000000..de73d3541
--- /dev/null
+++ b/.ci/scripts/windows/upload.sh
@@ -0,0 +1,13 @@
+#!/bin/bash -ex
+
+. .ci/scripts/common/pre-upload.sh
+
+REV_NAME="yuzu-windows-mingw-${GITDATE}-${GITREV}"
+ARCHIVE_NAME="${REV_NAME}.tar.gz"
+COMPRESSION_FLAGS="-czvf"
+
+mkdir "$REV_NAME"
+# get around the permission issues
+cp -r package/* "$REV_NAME"
+
+. .ci/scripts/common/post-upload.sh